#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 158
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 75
#define ALIAS_COUNT 0
#define TOKEN_COUNT 42
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 1

enum {
  sym_identifier = 1,
  anon_sym_COLON = 2,
  anon_sym_EQ = 3,
  anon_sym_LBRACK = 4,
  anon_sym_RBRACK = 5,
  anon_sym_LPAREN = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_TILDE = 11,
  sym_numeric = 12,
  anon_sym_true = 13,
  anon_sym_false = 14,
  sym_string = 15,
  anon_sym_of = 16,
  anon_sym_if = 17,
  anon_sym_then = 18,
  anon_sym_else = 19,
  anon_sym_LT_DASH = 20,
  anon_sym_let = 21,
  anon_sym_in = 22,
  anon_sym_BANG = 23,
  anon_sym_EQ_EQ = 24,
  anon_sym_BANG_EQ = 25,
  anon_sym_GT = 26,
  anon_sym_GT_EQ = 27,
  anon_sym_LT = 28,
  anon_sym_LT_EQ = 29,
  anon_sym_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_BANG_CARET = 33,
  anon_sym_PLUS = 34,
  anon_sym_DASH = 35,
  anon_sym_PERCENT = 36,
  anon_sym_STAR = 37,
  anon_sym_SLASH = 38,
  sym_exp = 39,
  anon_sym_POUND = 40,
  aux_sym_comment_token1 = 41,
  sym_source_file = 42,
  sym_definition = 43,
  sym_base_type = 44,
  sym_list_type = 45,
  sym_tuple_type = 46,
  sym_generics = 47,
  sym_general_type = 48,
  sym_named_arguments = 49,
  sym_named_argument = 50,
  sym_expression = 51,
  sym_simple = 52,
  sym_bool = 53,
  sym_list = 54,
  sym_empty_list = 55,
  sym_full_list = 56,
  sym_tuple = 57,
  sym_if = 58,
  sym_list_unpack = 59,
  sym_let = 60,
  sym_tuple_of_identifiers = 61,
  sym_not = 62,
  sym_call = 63,
  sym_generic_resolution = 64,
  sym_comparator = 65,
  sym_logical = 66,
  sym_add_sub = 67,
  sym_mult_div = 68,
  sym_comment = 69,
  aux_sym_source_file_repeat1 = 70,
  aux_sym_tuple_type_repeat1 = 71,
  aux_sym_generics_repeat1 = 72,
  aux_sym_named_arguments_repeat1 = 73,
  aux_sym_full_list_repeat1 = 74,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_TILDE] = "~",
  [sym_numeric] = "numeric",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_string] = "string",
  [anon_sym_of] = "of",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_else] = "else",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_let] = "let",
  [anon_sym_in] = "in",
  [anon_sym_BANG] = "!",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_BANG_CARET] = "!^",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [sym_exp] = "exp",
  [anon_sym_POUND] = "#",
  [aux_sym_comment_token1] = "comment_token1",
  [sym_source_file] = "source_file",
  [sym_definition] = "definition",
  [sym_base_type] = "base_type",
  [sym_list_type] = "list_type",
  [sym_tuple_type] = "tuple_type",
  [sym_generics] = "generics",
  [sym_general_type] = "general_type",
  [sym_named_arguments] = "named_arguments",
  [sym_named_argument] = "named_argument",
  [sym_expression] = "expression",
  [sym_simple] = "simple",
  [sym_bool] = "bool",
  [sym_list] = "list",
  [sym_empty_list] = "empty_list",
  [sym_full_list] = "full_list",
  [sym_tuple] = "tuple",
  [sym_if] = "if",
  [sym_list_unpack] = "list_unpack",
  [sym_let] = "let",
  [sym_tuple_of_identifiers] = "tuple_of_identifiers",
  [sym_not] = "not",
  [sym_call] = "call",
  [sym_generic_resolution] = "generic_resolution",
  [sym_comparator] = "comparator",
  [sym_logical] = "logical",
  [sym_add_sub] = "add_sub",
  [sym_mult_div] = "mult_div",
  [sym_comment] = "comment",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_generics_repeat1] = "generics_repeat1",
  [aux_sym_named_arguments_repeat1] = "named_arguments_repeat1",
  [aux_sym_full_list_repeat1] = "full_list_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_numeric] = sym_numeric,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_string] = sym_string,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_BANG_CARET] = anon_sym_BANG_CARET,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_exp] = sym_exp,
  [anon_sym_POUND] = anon_sym_POUND,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [sym_source_file] = sym_source_file,
  [sym_definition] = sym_definition,
  [sym_base_type] = sym_base_type,
  [sym_list_type] = sym_list_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_generics] = sym_generics,
  [sym_general_type] = sym_general_type,
  [sym_named_arguments] = sym_named_arguments,
  [sym_named_argument] = sym_named_argument,
  [sym_expression] = sym_expression,
  [sym_simple] = sym_simple,
  [sym_bool] = sym_bool,
  [sym_list] = sym_list,
  [sym_empty_list] = sym_empty_list,
  [sym_full_list] = sym_full_list,
  [sym_tuple] = sym_tuple,
  [sym_if] = sym_if,
  [sym_list_unpack] = sym_list_unpack,
  [sym_let] = sym_let,
  [sym_tuple_of_identifiers] = sym_tuple_of_identifiers,
  [sym_not] = sym_not,
  [sym_call] = sym_call,
  [sym_generic_resolution] = sym_generic_resolution,
  [sym_comparator] = sym_comparator,
  [sym_logical] = sym_logical,
  [sym_add_sub] = sym_add_sub,
  [sym_mult_div] = sym_mult_div,
  [sym_comment] = sym_comment,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_generics_repeat1] = aux_sym_generics_repeat1,
  [aux_sym_named_arguments_repeat1] = aux_sym_named_arguments_repeat1,
  [aux_sym_full_list_repeat1] = aux_sym_full_list_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_numeric] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_exp] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_base_type] = {
    .visible = true,
    .named = true,
  },
  [sym_list_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generics] = {
    .visible = true,
    .named = true,
  },
  [sym_general_type] = {
    .visible = true,
    .named = true,
  },
  [sym_named_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_named_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_simple] = {
    .visible = true,
    .named = true,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_list] = {
    .visible = true,
    .named = true,
  },
  [sym_full_list] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_list_unpack] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_of_identifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_not] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_comparator] = {
    .visible = true,
    .named = true,
  },
  [sym_logical] = {
    .visible = true,
    .named = true,
  },
  [sym_add_sub] = {
    .visible = true,
    .named = true,
  },
  [sym_mult_div] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generics_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_full_list_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(10);
      if (lookahead == '!') ADVANCE(28);
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(45);
      if (lookahead == '%') ADVANCE(41);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '(') ADVANCE(16);
      if (lookahead == ')') ADVANCE(18);
      if (lookahead == '*') ADVANCE(42);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == ',') ADVANCE(17);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '/') ADVANCE(43);
      if (lookahead == ':') ADVANCE(11);
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(31);
      if (lookahead == '[') ADVANCE(14);
      if (lookahead == ']') ADVANCE(15);
      if (lookahead == '^') ADVANCE(37);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(36);
      if (lookahead == '}') ADVANCE(20);
      if (lookahead == '~') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(27);
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(45);
      if (lookahead == '(') ADVANCE(16);
      if (lookahead == ')') ADVANCE(18);
      if (lookahead == '-') ADVANCE(4);
      if (lookahead == '0') ADVANCE(23);
      if (lookahead == ':') ADVANCE(11);
      if (lookahead == '<') ADVANCE(3);
      if (lookahead == '=') ADVANCE(12);
      if (lookahead == '[') ADVANCE(14);
      if (lookahead == ']') ADVANCE(15);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(24);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(7);
      if (lookahead == '\t' ||
          (' ' <= lookahead && lookahead <= '~')) ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '-') ADVANCE(26);
      END_STATE();
    case 4:
      if (lookahead == '0') ADVANCE(23);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(24);
      END_STATE();
    case 5:
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '^') ADVANCE(38);
      END_STATE();
    case 6:
      if (lookahead == '=') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(2);
      END_STATE();
    case 8:
      if (eof) ADVANCE(10);
      if (lookahead == '!') ADVANCE(5);
      if (lookahead == '#') ADVANCE(45);
      if (lookahead == '%') ADVANCE(41);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '(') ADVANCE(16);
      if (lookahead == ')') ADVANCE(18);
      if (lookahead == '*') ADVANCE(42);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == ',') ADVANCE(17);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '/') ADVANCE(43);
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(31);
      if (lookahead == ']') ADVANCE(15);
      if (lookahead == '^') ADVANCE(37);
      if (lookahead == '|') ADVANCE(36);
      if (lookahead == '}') ADVANCE(20);
      if (lookahead == '~') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 9:
      if (eof) ADVANCE(10);
      if (lookahead == '!') ADVANCE(5);
      if (lookahead == '#') ADVANCE(45);
      if (lookahead == '%') ADVANCE(41);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '(') ADVANCE(16);
      if (lookahead == ')') ADVANCE(18);
      if (lookahead == '*') ADVANCE(42);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == ',') ADVANCE(17);
      if (lookahead == '-') ADVANCE(40);
      if (lookahead == '/') ADVANCE(43);
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == '=') ADVANCE(6);
      if (lookahead == '>') ADVANCE(31);
      if (lookahead == ']') ADVANCE(15);
      if (lookahead == '^') ADVANCE(37);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(36);
      if (lookahead == '}') ADVANCE(20);
      if (lookahead == '~') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(29);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_numeric);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_numeric);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '^') ADVANCE(38);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(32);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_BANG_CARET);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(44);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_exp);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(48);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '#') ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(48);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'e') ADVANCE(1);
      if (lookahead == 'f') ADVANCE(2);
      if (lookahead == 'i') ADVANCE(3);
      if (lookahead == 'l') ADVANCE(4);
      if (lookahead == 'o') ADVANCE(5);
      if (lookahead == 't') ADVANCE(6);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'l') ADVANCE(7);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(8);
      END_STATE();
    case 3:
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(11);
      END_STATE();
    case 5:
      if (lookahead == 'f') ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(14);
      END_STATE();
    case 7:
      if (lookahead == 's') ADVANCE(15);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(16);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 11:
      if (lookahead == 't') ADVANCE(17);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(18);
      END_STATE();
    case 14:
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 16:
      if (lookahead == 's') ADVANCE(21);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(23);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 9},
  [3] = {.lex_state = 9},
  [4] = {.lex_state = 9},
  [5] = {.lex_state = 9},
  [6] = {.lex_state = 9},
  [7] = {.lex_state = 9},
  [8] = {.lex_state = 9},
  [9] = {.lex_state = 8},
  [10] = {.lex_state = 8},
  [11] = {.lex_state = 8},
  [12] = {.lex_state = 8},
  [13] = {.lex_state = 8},
  [14] = {.lex_state = 8},
  [15] = {.lex_state = 9},
  [16] = {.lex_state = 9},
  [17] = {.lex_state = 9},
  [18] = {.lex_state = 9},
  [19] = {.lex_state = 9},
  [20] = {.lex_state = 9},
  [21] = {.lex_state = 9},
  [22] = {.lex_state = 9},
  [23] = {.lex_state = 9},
  [24] = {.lex_state = 9},
  [25] = {.lex_state = 9},
  [26] = {.lex_state = 9},
  [27] = {.lex_state = 9},
  [28] = {.lex_state = 9},
  [29] = {.lex_state = 9},
  [30] = {.lex_state = 9},
  [31] = {.lex_state = 9},
  [32] = {.lex_state = 9},
  [33] = {.lex_state = 9},
  [34] = {.lex_state = 9},
  [35] = {.lex_state = 9},
  [36] = {.lex_state = 9},
  [37] = {.lex_state = 9},
  [38] = {.lex_state = 9},
  [39] = {.lex_state = 9},
  [40] = {.lex_state = 9},
  [41] = {.lex_state = 9},
  [42] = {.lex_state = 9},
  [43] = {.lex_state = 9},
  [44] = {.lex_state = 9},
  [45] = {.lex_state = 9},
  [46] = {.lex_state = 9},
  [47] = {.lex_state = 9},
  [48] = {.lex_state = 1},
  [49] = {.lex_state = 1},
  [50] = {.lex_state = 1},
  [51] = {.lex_state = 1},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 1},
  [55] = {.lex_state = 1},
  [56] = {.lex_state = 1},
  [57] = {.lex_state = 1},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 1},
  [60] = {.lex_state = 1},
  [61] = {.lex_state = 1},
  [62] = {.lex_state = 1},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 1},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 1},
  [72] = {.lex_state = 1},
  [73] = {.lex_state = 9},
  [74] = {.lex_state = 9},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 1},
  [77] = {.lex_state = 1},
  [78] = {.lex_state = 1},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 0},
  [81] = {.lex_state = 0},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 0},
  [88] = {.lex_state = 1},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 0},
  [92] = {.lex_state = 0},
  [93] = {.lex_state = 0},
  [94] = {.lex_state = 0},
  [95] = {.lex_state = 0},
  [96] = {.lex_state = 0},
  [97] = {.lex_state = 0},
  [98] = {.lex_state = 1},
  [99] = {.lex_state = 1},
  [100] = {.lex_state = 0},
  [101] = {.lex_state = 0},
  [102] = {.lex_state = 0},
  [103] = {.lex_state = 0},
  [104] = {.lex_state = 0},
  [105] = {.lex_state = 0},
  [106] = {.lex_state = 0},
  [107] = {.lex_state = 0},
  [108] = {.lex_state = 1},
  [109] = {.lex_state = 0},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 1},
  [112] = {.lex_state = 1},
  [113] = {.lex_state = 0},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 0},
  [116] = {.lex_state = 0},
  [117] = {.lex_state = 0},
  [118] = {.lex_state = 1},
  [119] = {.lex_state = 0},
  [120] = {.lex_state = 0},
  [121] = {.lex_state = 0},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 0},
  [124] = {.lex_state = 0},
  [125] = {.lex_state = 0},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 0},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 0},
  [130] = {.lex_state = 0},
  [131] = {.lex_state = 0},
  [132] = {.lex_state = 1},
  [133] = {.lex_state = 1},
  [134] = {.lex_state = 0},
  [135] = {.lex_state = 0},
  [136] = {.lex_state = 1},
  [137] = {.lex_state = 1},
  [138] = {.lex_state = 1},
  [139] = {.lex_state = 0},
  [140] = {.lex_state = 1},
  [141] = {.lex_state = 0},
  [142] = {.lex_state = 0},
  [143] = {.lex_state = 1},
  [144] = {.lex_state = 0},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 0},
  [149] = {.lex_state = 0},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 0},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 47},
  [155] = {.lex_state = 1},
  [156] = {.lex_state = 0},
  [157] = {(TSStateId)(-1)},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_BANG_CARET] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [sym_exp] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(156),
    [sym_definition] = STATE(124),
    [sym_comment] = STATE(1),
    [aux_sym_source_file_repeat1] = STATE(96),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(3),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    STATE(2), 1,
      sym_comment,
    STATE(24), 1,
      sym_tuple,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(11), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(9), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [52] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(3), 1,
      sym_comment,
    STATE(24), 1,
      sym_tuple,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(15), 4,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(17), 4,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [120] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(4), 1,
      sym_comment,
    STATE(24), 1,
      sym_tuple,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
    ACTIONS(35), 4,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(37), 4,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
  [188] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(5), 1,
      sym_comment,
    STATE(24), 1,
      sym_tuple,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
    ACTIONS(41), 6,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(39), 9,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [250] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    STATE(6), 1,
      sym_comment,
    STATE(24), 1,
      sym_tuple,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(41), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(39), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [302] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(7), 1,
      sym_comment,
    STATE(24), 1,
      sym_tuple,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(41), 6,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(39), 16,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
  [360] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_exp,
    STATE(8), 1,
      sym_comment,
    STATE(24), 1,
      sym_tuple,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(41), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(39), 17,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
  [414] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(9), 1,
      sym_comment,
    ACTIONS(45), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(43), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [453] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(10), 1,
      sym_comment,
    ACTIONS(49), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(47), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [492] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(11), 1,
      sym_comment,
    ACTIONS(53), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(51), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [531] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(12), 1,
      sym_comment,
    ACTIONS(57), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(55), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [570] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(13), 1,
      sym_comment,
    ACTIONS(61), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(59), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [609] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(14), 1,
      sym_comment,
    ACTIONS(65), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(63), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [648] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(15), 1,
      sym_comment,
    STATE(16), 1,
      sym_tuple_type,
    ACTIONS(69), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(67), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [688] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(16), 1,
      sym_comment,
    ACTIONS(73), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(71), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [726] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(79), 1,
      anon_sym_LBRACE,
    STATE(17), 1,
      sym_comment,
    ACTIONS(77), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(75), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [766] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(18), 1,
      sym_comment,
    ACTIONS(83), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(81), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [803] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(19), 1,
      sym_comment,
    ACTIONS(87), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(85), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [840] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(20), 1,
      sym_comment,
    STATE(24), 1,
      sym_tuple,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(89), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [901] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(21), 1,
      sym_comment,
    ACTIONS(93), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(91), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [938] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(22), 1,
      sym_comment,
    ACTIONS(77), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(75), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [975] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(23), 1,
      sym_comment,
    ACTIONS(97), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(95), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1012] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(24), 1,
      sym_comment,
    ACTIONS(101), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(99), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1049] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    ACTIONS(103), 1,
      anon_sym_RBRACK,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    STATE(24), 1,
      sym_tuple,
    STATE(25), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    STATE(121), 1,
      aux_sym_full_list_repeat1,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1114] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_RPAREN,
    STATE(24), 1,
      sym_tuple,
    STATE(26), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    STATE(120), 1,
      aux_sym_full_list_repeat1,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1179] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(27), 1,
      sym_comment,
    ACTIONS(113), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(111), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1216] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(28), 1,
      sym_comment,
    ACTIONS(117), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(115), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1253] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(29), 1,
      sym_comment,
    ACTIONS(121), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(119), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1290] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(30), 1,
      sym_comment,
    ACTIONS(117), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(115), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1327] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(31), 1,
      sym_comment,
    ACTIONS(125), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(123), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1364] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(32), 1,
      sym_comment,
    ACTIONS(129), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(127), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1401] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(33), 1,
      sym_comment,
    ACTIONS(133), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(131), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1438] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(34), 1,
      sym_comment,
    ACTIONS(137), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(135), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1475] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(35), 1,
      sym_comment,
    ACTIONS(141), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(139), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1512] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(36), 1,
      sym_comment,
    ACTIONS(145), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(143), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1549] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(37), 1,
      sym_comment,
    ACTIONS(149), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(147), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1586] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(24), 1,
      sym_tuple,
    STATE(38), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(151), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1646] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(24), 1,
      sym_tuple,
    STATE(39), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(153), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1706] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(24), 1,
      sym_tuple,
    STATE(40), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(155), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1766] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(24), 1,
      sym_tuple,
    STATE(41), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(157), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1826] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    STATE(24), 1,
      sym_tuple,
    STATE(42), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(159), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1886] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    ACTIONS(161), 1,
      anon_sym_in,
    STATE(24), 1,
      sym_tuple,
    STATE(43), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1945] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    ACTIONS(163), 1,
      anon_sym_then,
    STATE(24), 1,
      sym_tuple,
    STATE(44), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2004] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    ACTIONS(165), 1,
      anon_sym_then,
    STATE(24), 1,
      sym_tuple,
    STATE(45), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2063] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    ACTIONS(167), 1,
      anon_sym_then,
    STATE(24), 1,
      sym_tuple,
    STATE(46), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2122] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(19), 1,
      anon_sym_TILDE,
    ACTIONS(29), 1,
      anon_sym_STAR,
    ACTIONS(31), 1,
      anon_sym_SLASH,
    ACTIONS(33), 1,
      sym_exp,
    ACTIONS(169), 1,
      anon_sym_else,
    STATE(24), 1,
      sym_tuple,
    STATE(47), 1,
      sym_comment,
    STATE(62), 1,
      sym_comparator,
    STATE(69), 1,
      sym_mult_div,
    ACTIONS(23), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(68), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(27), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
    ACTIONS(21), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(25), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2181] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(175), 1,
      anon_sym_RBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(20), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(48), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2239] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    ACTIONS(187), 1,
      sym_identifier,
    ACTIONS(189), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_bool,
    STATE(26), 1,
      sym_expression,
    STATE(49), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2297] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    ACTIONS(191), 1,
      sym_identifier,
    ACTIONS(193), 1,
      anon_sym_LPAREN,
    STATE(22), 1,
      sym_bool,
    STATE(45), 1,
      sym_expression,
    STATE(50), 1,
      sym_comment,
    STATE(149), 1,
      sym_list_unpack,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2355] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    ACTIONS(189), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_bool,
    STATE(26), 1,
      sym_expression,
    STATE(51), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2413] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    ACTIONS(195), 1,
      anon_sym_RBRACK,
    STATE(22), 1,
      sym_bool,
    STATE(25), 1,
      sym_expression,
    STATE(52), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2471] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    ACTIONS(197), 1,
      anon_sym_RPAREN,
    STATE(20), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(53), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2529] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    ACTIONS(199), 1,
      anon_sym_RPAREN,
    STATE(20), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(54), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2587] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    ACTIONS(201), 1,
      anon_sym_RBRACK,
    STATE(20), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(55), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2645] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(39), 1,
      sym_expression,
    STATE(56), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2700] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(6), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(57), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2755] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(2), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(58), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2810] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(42), 1,
      sym_expression,
    STATE(59), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2865] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(3), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(60), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2920] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(4), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(61), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [2975] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(5), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(62), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3030] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(40), 1,
      sym_expression,
    STATE(63), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3085] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(41), 1,
      sym_expression,
    STATE(64), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3140] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(47), 1,
      sym_expression,
    STATE(65), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3195] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(20), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(66), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3250] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(38), 1,
      sym_expression,
    STATE(67), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3305] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(7), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(68), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3360] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(8), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(69), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3415] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(43), 1,
      sym_expression,
    STATE(70), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3470] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(44), 1,
      sym_expression,
    STATE(71), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3525] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_LBRACK,
    ACTIONS(181), 1,
      anon_sym_if,
    ACTIONS(183), 1,
      anon_sym_let,
    ACTIONS(185), 1,
      anon_sym_BANG,
    STATE(22), 1,
      sym_bool,
    STATE(46), 1,
      sym_expression,
    STATE(72), 1,
      sym_comment,
    ACTIONS(177), 2,
      sym_numeric,
      sym_string,
    ACTIONS(179), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(29), 2,
      sym_empty_list,
      sym_full_list,
    STATE(30), 2,
      sym_if,
      sym_let,
    STATE(28), 6,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_not,
      sym_call,
      sym_generic_resolution,
  [3580] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(79), 1,
      anon_sym_LBRACE,
    ACTIONS(203), 1,
      anon_sym_TILDE,
    STATE(73), 1,
      sym_comment,
    ACTIONS(77), 3,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(75), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [3616] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(79), 1,
      anon_sym_LBRACE,
    ACTIONS(205), 1,
      anon_sym_TILDE,
    STATE(74), 1,
      sym_comment,
    ACTIONS(77), 3,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(75), 15,
      anon_sym_LPAREN,
      anon_sym_then,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [3651] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(75), 1,
      sym_comment,
    ACTIONS(207), 5,
      sym_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_let,
    ACTIONS(209), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_numeric,
      sym_string,
      anon_sym_BANG,
  [3672] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(76), 1,
      sym_comment,
    ACTIONS(211), 5,
      sym_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_let,
    ACTIONS(213), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_numeric,
      sym_string,
      anon_sym_BANG,
  [3693] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(77), 1,
      sym_comment,
    ACTIONS(215), 5,
      sym_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_let,
    ACTIONS(217), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_numeric,
      sym_string,
      anon_sym_BANG,
  [3714] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(78), 1,
      sym_comment,
    ACTIONS(219), 5,
      sym_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_let,
    ACTIONS(221), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_numeric,
      sym_string,
      anon_sym_BANG,
  [3735] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    ACTIONS(229), 1,
      anon_sym_RBRACE,
    STATE(79), 1,
      sym_comment,
    STATE(92), 1,
      sym_base_type,
    STATE(109), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3764] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_RPAREN,
    STATE(80), 1,
      sym_comment,
    STATE(92), 1,
      sym_base_type,
    STATE(103), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3793] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    ACTIONS(233), 1,
      anon_sym_RPAREN,
    STATE(81), 1,
      sym_comment,
    STATE(92), 1,
      sym_base_type,
    STATE(109), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3822] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    ACTIONS(235), 1,
      anon_sym_RPAREN,
    STATE(82), 1,
      sym_comment,
    STATE(92), 1,
      sym_base_type,
    STATE(109), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3851] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_RBRACE,
    STATE(83), 1,
      sym_comment,
    STATE(92), 1,
      sym_base_type,
    STATE(109), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3880] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    STATE(84), 1,
      sym_comment,
    STATE(92), 1,
      sym_base_type,
    STATE(128), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3906] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    STATE(15), 1,
      sym_base_type,
    STATE(18), 1,
      sym_general_type,
    STATE(85), 1,
      sym_comment,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3932] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    STATE(86), 1,
      sym_comment,
    STATE(92), 1,
      sym_base_type,
    STATE(119), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3958] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym_comment,
    STATE(92), 1,
      sym_base_type,
    STATE(109), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3984] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(239), 1,
      anon_sym_COLON,
    ACTIONS(241), 1,
      anon_sym_EQ,
    ACTIONS(243), 1,
      anon_sym_LPAREN,
    ACTIONS(245), 1,
      anon_sym_LBRACE,
    STATE(88), 1,
      sym_comment,
    STATE(98), 1,
      sym_generics,
    STATE(136), 1,
      sym_named_arguments,
  [4009] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    STATE(89), 1,
      sym_comment,
    STATE(141), 1,
      sym_base_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [4032] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    STATE(90), 1,
      sym_comment,
    STATE(118), 1,
      sym_base_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [4055] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(223), 1,
      sym_identifier,
    ACTIONS(225), 1,
      anon_sym_LBRACK,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    STATE(91), 1,
      sym_comment,
    STATE(111), 1,
      sym_base_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [4078] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(227), 1,
      anon_sym_LPAREN,
    STATE(16), 1,
      sym_tuple_type,
    STATE(92), 1,
      sym_comment,
    ACTIONS(67), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [4096] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(247), 1,
      ts_builtin_sym_end,
    ACTIONS(249), 1,
      sym_identifier,
    STATE(124), 1,
      sym_definition,
    STATE(93), 2,
      sym_comment,
      aux_sym_source_file_repeat1,
  [4113] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(252), 1,
      anon_sym_COMMA,
    ACTIONS(89), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(94), 2,
      sym_comment,
      aux_sym_full_list_repeat1,
  [4128] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      anon_sym_COMMA,
    ACTIONS(258), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(95), 2,
      sym_comment,
      aux_sym_generics_repeat1,
  [4143] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(260), 1,
      ts_builtin_sym_end,
    STATE(93), 1,
      aux_sym_source_file_repeat1,
    STATE(96), 1,
      sym_comment,
    STATE(124), 1,
      sym_definition,
  [4162] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(262), 1,
      anon_sym_COMMA,
    ACTIONS(265), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(97), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [4177] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(243), 1,
      anon_sym_LPAREN,
    ACTIONS(267), 1,
      anon_sym_COLON,
    ACTIONS(269), 1,
      anon_sym_EQ,
    STATE(98), 1,
      sym_comment,
    STATE(151), 1,
      sym_named_arguments,
  [4196] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(99), 1,
      sym_comment,
    ACTIONS(271), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN,
  [4208] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(233), 1,
      anon_sym_RPAREN,
    ACTIONS(273), 1,
      anon_sym_COMMA,
    STATE(97), 1,
      aux_sym_tuple_type_repeat1,
    STATE(100), 1,
      sym_comment,
  [4224] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(277), 1,
      anon_sym_RPAREN,
    STATE(101), 1,
      sym_comment,
    STATE(129), 1,
      sym_named_argument,
  [4240] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(279), 1,
      anon_sym_COMMA,
    ACTIONS(282), 1,
      anon_sym_RPAREN,
    STATE(102), 2,
      sym_comment,
      aux_sym_named_arguments_repeat1,
  [4254] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(286), 1,
      anon_sym_RPAREN,
    STATE(100), 1,
      aux_sym_tuple_type_repeat1,
    STATE(103), 1,
      sym_comment,
  [4270] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(104), 1,
      sym_comment,
    ACTIONS(258), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [4282] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(288), 1,
      anon_sym_RPAREN,
    STATE(105), 1,
      sym_comment,
    STATE(129), 1,
      sym_named_argument,
  [4298] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(288), 1,
      anon_sym_RPAREN,
    ACTIONS(290), 1,
      anon_sym_COMMA,
    STATE(102), 1,
      aux_sym_named_arguments_repeat1,
    STATE(106), 1,
      sym_comment,
  [4314] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(292), 1,
      anon_sym_RPAREN,
    STATE(107), 1,
      sym_comment,
    STATE(114), 1,
      sym_named_argument,
  [4330] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(108), 1,
      sym_comment,
    ACTIONS(294), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN,
  [4342] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(109), 1,
      sym_comment,
    ACTIONS(265), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [4354] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(296), 1,
      anon_sym_COMMA,
    ACTIONS(298), 1,
      anon_sym_RBRACE,
    STATE(95), 1,
      aux_sym_generics_repeat1,
    STATE(110), 1,
      sym_comment,
  [4370] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(243), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_EQ,
    STATE(111), 1,
      sym_comment,
    STATE(140), 1,
      sym_named_arguments,
  [4386] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(112), 1,
      sym_comment,
    ACTIONS(302), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN,
  [4398] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(304), 1,
      sym_identifier,
    ACTIONS(306), 1,
      anon_sym_LPAREN,
    STATE(113), 1,
      sym_comment,
    STATE(147), 1,
      sym_tuple_of_identifiers,
  [4414] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(308), 1,
      anon_sym_COMMA,
    ACTIONS(310), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_named_arguments_repeat1,
    STATE(114), 1,
      sym_comment,
  [4430] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(312), 1,
      anon_sym_COMMA,
    ACTIONS(314), 1,
      anon_sym_RBRACE,
    STATE(110), 1,
      aux_sym_generics_repeat1,
    STATE(115), 1,
      sym_comment,
  [4446] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(316), 1,
      anon_sym_COMMA,
    ACTIONS(318), 1,
      anon_sym_RPAREN,
    STATE(116), 1,
      sym_comment,
    STATE(117), 1,
      aux_sym_generics_repeat1,
  [4462] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(320), 1,
      anon_sym_COMMA,
    ACTIONS(322), 1,
      anon_sym_RPAREN,
    STATE(95), 1,
      aux_sym_generics_repeat1,
    STATE(117), 1,
      sym_comment,
  [4478] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(243), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      anon_sym_EQ,
    STATE(118), 1,
      sym_comment,
    STATE(155), 1,
      sym_named_arguments,
  [4494] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(326), 1,
      anon_sym_COMMA,
    ACTIONS(328), 1,
      anon_sym_RBRACE,
    STATE(119), 1,
      sym_comment,
    STATE(122), 1,
      aux_sym_tuple_type_repeat1,
  [4510] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(199), 1,
      anon_sym_RPAREN,
    ACTIONS(330), 1,
      anon_sym_COMMA,
    STATE(94), 1,
      aux_sym_full_list_repeat1,
    STATE(120), 1,
      sym_comment,
  [4526] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(201), 1,
      anon_sym_RBRACK,
    ACTIONS(332), 1,
      anon_sym_COMMA,
    STATE(94), 1,
      aux_sym_full_list_repeat1,
    STATE(121), 1,
      sym_comment,
  [4542] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(229), 1,
      anon_sym_RBRACE,
    ACTIONS(334), 1,
      anon_sym_COMMA,
    STATE(97), 1,
      aux_sym_tuple_type_repeat1,
    STATE(122), 1,
      sym_comment,
  [4558] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(275), 1,
      sym_identifier,
    STATE(123), 1,
      sym_comment,
    STATE(129), 1,
      sym_named_argument,
  [4571] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(124), 1,
      sym_comment,
    ACTIONS(336), 2,
      ts_builtin_sym_end,
      sym_identifier,
  [4582] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(338), 1,
      sym_identifier,
    ACTIONS(340), 1,
      anon_sym_RPAREN,
    STATE(125), 1,
      sym_comment,
  [4595] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(322), 1,
      anon_sym_RPAREN,
    ACTIONS(338), 1,
      sym_identifier,
    STATE(126), 1,
      sym_comment,
  [4608] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(338), 1,
      sym_identifier,
    ACTIONS(342), 1,
      anon_sym_RBRACE,
    STATE(127), 1,
      sym_comment,
  [4621] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(128), 1,
      sym_comment,
    ACTIONS(344), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4632] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(129), 1,
      sym_comment,
    ACTIONS(282), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4643] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(298), 1,
      anon_sym_RBRACE,
    ACTIONS(338), 1,
      sym_identifier,
    STATE(130), 1,
      sym_comment,
  [4656] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(346), 1,
      sym_identifier,
    STATE(131), 1,
      sym_comment,
  [4666] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(348), 1,
      anon_sym_LT_DASH,
    STATE(132), 1,
      sym_comment,
  [4676] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(350), 1,
      anon_sym_EQ,
    STATE(133), 1,
      sym_comment,
  [4686] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(352), 1,
      anon_sym_COLON,
    STATE(134), 1,
      sym_comment,
  [4696] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(338), 1,
      sym_identifier,
    STATE(135), 1,
      sym_comment,
  [4706] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(269), 1,
      anon_sym_EQ,
    STATE(136), 1,
      sym_comment,
  [4716] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(354), 1,
      anon_sym_EQ,
    STATE(137), 1,
      sym_comment,
  [4726] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(356), 1,
      anon_sym_EQ,
    STATE(138), 1,
      sym_comment,
  [4736] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(358), 1,
      sym_identifier,
    STATE(139), 1,
      sym_comment,
  [4746] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(360), 1,
      anon_sym_EQ,
    STATE(140), 1,
      sym_comment,
  [4756] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(362), 1,
      anon_sym_RBRACK,
    STATE(141), 1,
      sym_comment,
  [4766] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(364), 1,
      anon_sym_RPAREN,
    STATE(142), 1,
      sym_comment,
  [4776] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(366), 1,
      anon_sym_EQ,
    STATE(143), 1,
      sym_comment,
  [4786] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(368), 1,
      sym_identifier,
    STATE(144), 1,
      sym_comment,
  [4796] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(370), 1,
      anon_sym_LT_DASH,
    STATE(145), 1,
      sym_comment,
  [4806] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_LT_DASH,
    STATE(146), 1,
      sym_comment,
  [4816] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(374), 1,
      anon_sym_LT_DASH,
    STATE(147), 1,
      sym_comment,
  [4826] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(376), 1,
      sym_identifier,
    STATE(148), 1,
      sym_comment,
  [4836] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(165), 1,
      anon_sym_then,
    STATE(149), 1,
      sym_comment,
  [4846] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(378), 1,
      anon_sym_LT_DASH,
    STATE(150), 1,
      sym_comment,
  [4856] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(324), 1,
      anon_sym_EQ,
    STATE(151), 1,
      sym_comment,
  [4866] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(380), 1,
      anon_sym_of,
    STATE(152), 1,
      sym_comment,
  [4876] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(382), 1,
      anon_sym_LT_DASH,
    STATE(153), 1,
      sym_comment,
  [4886] = 3,
    ACTIONS(384), 1,
      anon_sym_POUND,
    ACTIONS(386), 1,
      aux_sym_comment_token1,
    STATE(154), 1,
      sym_comment,
  [4896] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(300), 1,
      anon_sym_EQ,
    STATE(155), 1,
      sym_comment,
  [4906] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(388), 1,
      ts_builtin_sym_end,
    STATE(156), 1,
      sym_comment,
  [4916] = 1,
    ACTIONS(390), 1,
      ts_builtin_sym_end,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 52,
  [SMALL_STATE(4)] = 120,
  [SMALL_STATE(5)] = 188,
  [SMALL_STATE(6)] = 250,
  [SMALL_STATE(7)] = 302,
  [SMALL_STATE(8)] = 360,
  [SMALL_STATE(9)] = 414,
  [SMALL_STATE(10)] = 453,
  [SMALL_STATE(11)] = 492,
  [SMALL_STATE(12)] = 531,
  [SMALL_STATE(13)] = 570,
  [SMALL_STATE(14)] = 609,
  [SMALL_STATE(15)] = 648,
  [SMALL_STATE(16)] = 688,
  [SMALL_STATE(17)] = 726,
  [SMALL_STATE(18)] = 766,
  [SMALL_STATE(19)] = 803,
  [SMALL_STATE(20)] = 840,
  [SMALL_STATE(21)] = 901,
  [SMALL_STATE(22)] = 938,
  [SMALL_STATE(23)] = 975,
  [SMALL_STATE(24)] = 1012,
  [SMALL_STATE(25)] = 1049,
  [SMALL_STATE(26)] = 1114,
  [SMALL_STATE(27)] = 1179,
  [SMALL_STATE(28)] = 1216,
  [SMALL_STATE(29)] = 1253,
  [SMALL_STATE(30)] = 1290,
  [SMALL_STATE(31)] = 1327,
  [SMALL_STATE(32)] = 1364,
  [SMALL_STATE(33)] = 1401,
  [SMALL_STATE(34)] = 1438,
  [SMALL_STATE(35)] = 1475,
  [SMALL_STATE(36)] = 1512,
  [SMALL_STATE(37)] = 1549,
  [SMALL_STATE(38)] = 1586,
  [SMALL_STATE(39)] = 1646,
  [SMALL_STATE(40)] = 1706,
  [SMALL_STATE(41)] = 1766,
  [SMALL_STATE(42)] = 1826,
  [SMALL_STATE(43)] = 1886,
  [SMALL_STATE(44)] = 1945,
  [SMALL_STATE(45)] = 2004,
  [SMALL_STATE(46)] = 2063,
  [SMALL_STATE(47)] = 2122,
  [SMALL_STATE(48)] = 2181,
  [SMALL_STATE(49)] = 2239,
  [SMALL_STATE(50)] = 2297,
  [SMALL_STATE(51)] = 2355,
  [SMALL_STATE(52)] = 2413,
  [SMALL_STATE(53)] = 2471,
  [SMALL_STATE(54)] = 2529,
  [SMALL_STATE(55)] = 2587,
  [SMALL_STATE(56)] = 2645,
  [SMALL_STATE(57)] = 2700,
  [SMALL_STATE(58)] = 2755,
  [SMALL_STATE(59)] = 2810,
  [SMALL_STATE(60)] = 2865,
  [SMALL_STATE(61)] = 2920,
  [SMALL_STATE(62)] = 2975,
  [SMALL_STATE(63)] = 3030,
  [SMALL_STATE(64)] = 3085,
  [SMALL_STATE(65)] = 3140,
  [SMALL_STATE(66)] = 3195,
  [SMALL_STATE(67)] = 3250,
  [SMALL_STATE(68)] = 3305,
  [SMALL_STATE(69)] = 3360,
  [SMALL_STATE(70)] = 3415,
  [SMALL_STATE(71)] = 3470,
  [SMALL_STATE(72)] = 3525,
  [SMALL_STATE(73)] = 3580,
  [SMALL_STATE(74)] = 3616,
  [SMALL_STATE(75)] = 3651,
  [SMALL_STATE(76)] = 3672,
  [SMALL_STATE(77)] = 3693,
  [SMALL_STATE(78)] = 3714,
  [SMALL_STATE(79)] = 3735,
  [SMALL_STATE(80)] = 3764,
  [SMALL_STATE(81)] = 3793,
  [SMALL_STATE(82)] = 3822,
  [SMALL_STATE(83)] = 3851,
  [SMALL_STATE(84)] = 3880,
  [SMALL_STATE(85)] = 3906,
  [SMALL_STATE(86)] = 3932,
  [SMALL_STATE(87)] = 3958,
  [SMALL_STATE(88)] = 3984,
  [SMALL_STATE(89)] = 4009,
  [SMALL_STATE(90)] = 4032,
  [SMALL_STATE(91)] = 4055,
  [SMALL_STATE(92)] = 4078,
  [SMALL_STATE(93)] = 4096,
  [SMALL_STATE(94)] = 4113,
  [SMALL_STATE(95)] = 4128,
  [SMALL_STATE(96)] = 4143,
  [SMALL_STATE(97)] = 4162,
  [SMALL_STATE(98)] = 4177,
  [SMALL_STATE(99)] = 4196,
  [SMALL_STATE(100)] = 4208,
  [SMALL_STATE(101)] = 4224,
  [SMALL_STATE(102)] = 4240,
  [SMALL_STATE(103)] = 4254,
  [SMALL_STATE(104)] = 4270,
  [SMALL_STATE(105)] = 4282,
  [SMALL_STATE(106)] = 4298,
  [SMALL_STATE(107)] = 4314,
  [SMALL_STATE(108)] = 4330,
  [SMALL_STATE(109)] = 4342,
  [SMALL_STATE(110)] = 4354,
  [SMALL_STATE(111)] = 4370,
  [SMALL_STATE(112)] = 4386,
  [SMALL_STATE(113)] = 4398,
  [SMALL_STATE(114)] = 4414,
  [SMALL_STATE(115)] = 4430,
  [SMALL_STATE(116)] = 4446,
  [SMALL_STATE(117)] = 4462,
  [SMALL_STATE(118)] = 4478,
  [SMALL_STATE(119)] = 4494,
  [SMALL_STATE(120)] = 4510,
  [SMALL_STATE(121)] = 4526,
  [SMALL_STATE(122)] = 4542,
  [SMALL_STATE(123)] = 4558,
  [SMALL_STATE(124)] = 4571,
  [SMALL_STATE(125)] = 4582,
  [SMALL_STATE(126)] = 4595,
  [SMALL_STATE(127)] = 4608,
  [SMALL_STATE(128)] = 4621,
  [SMALL_STATE(129)] = 4632,
  [SMALL_STATE(130)] = 4643,
  [SMALL_STATE(131)] = 4656,
  [SMALL_STATE(132)] = 4666,
  [SMALL_STATE(133)] = 4676,
  [SMALL_STATE(134)] = 4686,
  [SMALL_STATE(135)] = 4696,
  [SMALL_STATE(136)] = 4706,
  [SMALL_STATE(137)] = 4716,
  [SMALL_STATE(138)] = 4726,
  [SMALL_STATE(139)] = 4736,
  [SMALL_STATE(140)] = 4746,
  [SMALL_STATE(141)] = 4756,
  [SMALL_STATE(142)] = 4766,
  [SMALL_STATE(143)] = 4776,
  [SMALL_STATE(144)] = 4786,
  [SMALL_STATE(145)] = 4796,
  [SMALL_STATE(146)] = 4806,
  [SMALL_STATE(147)] = 4816,
  [SMALL_STATE(148)] = 4826,
  [SMALL_STATE(149)] = 4836,
  [SMALL_STATE(150)] = 4846,
  [SMALL_STATE(151)] = 4856,
  [SMALL_STATE(152)] = 4866,
  [SMALL_STATE(153)] = 4876,
  [SMALL_STATE(154)] = 4886,
  [SMALL_STATE(155)] = 4896,
  [SMALL_STATE(156)] = 4906,
  [SMALL_STATE(157)] = 4916,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [9] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not, 2),
  [11] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not, 2),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [15] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 6),
  [17] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 6),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [35] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 6),
  [37] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 6),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 3),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 3),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_type, 3),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_type, 3),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_type, 1),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_base_type, 1),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_general_type, 1),
  [69] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_general_type, 1),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_general_type, 2),
  [73] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_general_type, 2),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple, 1),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple, 1),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [81] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_list, 4),
  [83] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_list, 4),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_resolution, 5),
  [87] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_resolution, 5),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_full_list_repeat1, 2),
  [91] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_list, 4),
  [93] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_list, 4),
  [95] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool, 1),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool, 1),
  [99] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_resolution, 6),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_resolution, 6),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 1),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 1),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_resolution, 4),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_resolution, 4),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 4),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 4),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_list, 5),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_list, 5),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_list, 3),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_list, 3),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 5),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 5),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 6),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 4),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 7),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 5),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 3),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_unpack, 5),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_unpack, 7),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mult_div, 1),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mult_div, 1),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_add_sub, 1),
  [213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_sub, 1),
  [215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical, 1),
  [217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical, 1),
  [219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparator, 1),
  [221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparator, 1),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(88),
  [252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_full_list_repeat1, 2), SHIFT_REPEAT(66),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generics_repeat1, 2), SHIFT_REPEAT(135),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generics_repeat1, 2),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(87),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generics, 4),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_arguments_repeat1, 2), SHIFT_REPEAT(123),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_arguments_repeat1, 2),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generics, 3),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generics, 5),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_argument, 3),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 5),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 4),
  [356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 2),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 3),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_of_identifiers, 4),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_of_identifiers, 3),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_of_identifiers, 5),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [388] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_azor(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
